﻿CREATE FUNCTION ObtainClients
(
	@OrderBy NVarChar(20)
)
RETURNS @returntable TABLE
(
   RowNo          BigInt PRIMARY KEY NOT NULL,
   CustomerName   NVarChar(Max),
   Id             Int,
   PurchaseDate   DateTime,
   Amount         Decimal(18,2),
   CustomersId    Int
)
AS
BEGIN
	INSERT INTO @returntable
	SELECT ROW_NUMBER()OVER(ORDER BY 
      CASE @OrderBy
         WHEN 'PurchaseDate' THEN P.PurchaseDate
         WHEN 'Amount'       THEN P.Amount
         WHEN 'CustomersId'  THEN P.CustomersId
                             ELSE P.PurchaseDate
      END
          )RowNo,
          C.CustomerName,
          P.Id,
          P.PurchaseDate,
          P.Amount,
          P.CustomersId
   FROM Customers AS C
	INNER JOIN Purchases AS P
	ON C.Id = P.CustomersId
	RETURN
END
